Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fasterxml.jackson.databind.deser.std
Class CollectionDeserializer

    java.lang.Object
      com.fasterxml.jackson.databind.JsonDeserializer<T>
          com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
              com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase<Collection<Object>>
                  com.fasterxml.jackson.databind.deser.std.CollectionDeserializer

All Implemented Interfaces:
  ContextualDeserializer

    public class CollectionDeserializer

extends ContainerDeserializerBase<Collection<Object>>
implements ContextualDeserializer

Basic serializer that can take JSON "Array" structure and construct a `Collection` instance, with typed contents.

Note: for untyped content (one indicated by passing Object.class as the type), `UntypedObjectDeserializer` is used instead. It can also construct `List`s, but not with specific POJO types, only other containers and primitives/wrappers.

Nested Class Summary

Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`JsonDeserializer.None`

Field Summary
`protected JavaType` | `_collectionType`
`protected JsonDeserializer<Object>` | `_delegateDeserializer` Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.
`protected JsonDeserializer<Object>` | `_valueDeserializer` Value deserializer.
`protected ValueInstantiator` | `_valueInstantiator`
`protected TypeDeserializer` | `_valueTypeDeserializer` If element instances have polymorphic type information, this is the type deserializer that can handle it

Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer
`_valueClass`

Constructor Summary
`protected` | `CollectionDeserializer(CollectionDeserializer src)` Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.
`` | `CollectionDeserializer(JavaType collectionType, JsonDeserializer<Object> valueDeser, TypeDeserializer valueTypeDeser, ValueInstantiator valueInstantiator)` Constructor for context-free instances, where we do not yet know which property is using this deserializer.
`protected` | `CollectionDeserializer(JavaType collectionType, JsonDeserializer<Object> valueDeser, TypeDeserializer valueTypeDeser, ValueInstantiator valueInstantiator, JsonDeserializer<Object> delegateDeser)` Constructor used when creating contextualized instances.

Method Summary
`CollectionDeserializer` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to finalize setup of this deserializer, when it is known for which property deserializer is needed for.
`Collection<Object>` | `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`Collection<Object>` | `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Collection<Object> result)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
`Object` | `deserializeWithType(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
`JsonDeserializer<Object>` | `getContentDeserializer()` Accesor for deserializer use for deserializing content values.
`JavaType` | `getContentType()` Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
`protected CollectionDeserializer` | `withResolved(JsonDeserializer<?> dd, JsonDeserializer<?> vd, TypeDeserializer vtd)` Fluent-factory method call to construct contextual instance.

Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer
`_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, findDeserializer, getValueClass, getValueType, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`getEmptyValue, getKnownPropertyNames, getNullValue, getObjectIdReader, isCachable, unwrappingDeserializer`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _collectionType

    protected final JavaType _collectionType

### _valueDeserializer

    protected final JsonDeserializer<Object> _valueDeserializer

  Value deserializer.

### _valueTypeDeserializer

    protected final TypeDeserializer _valueTypeDeserializer

  If element instances have polymorphic type information, this is the type deserializer that can handle it

### _valueInstantiator

    protected final ValueInstantiator _valueInstantiator

### _delegateDeserializer

    protected final JsonDeserializer<Object> _delegateDeserializer

  Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.

Constructor Detail

### CollectionDeserializer

    public CollectionDeserializer(JavaType collectionType,
                                  JsonDeserializer<Object> valueDeser,
                                  TypeDeserializer valueTypeDeser,
                                  ValueInstantiator valueInstantiator)

  Constructor for context-free instances, where we do not yet know which property is using this deserializer.

### CollectionDeserializer

    protected CollectionDeserializer(JavaType collectionType,
                                     JsonDeserializer<Object> valueDeser,
                                     TypeDeserializer valueTypeDeser,
                                     ValueInstantiator valueInstantiator,
                                     JsonDeserializer<Object> delegateDeser)

  Constructor used when creating contextualized instances.

### CollectionDeserializer

    protected CollectionDeserializer(CollectionDeserializer src)

  Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.

Method Detail

### withResolved

    protected CollectionDeserializer withResolved(JsonDeserializer<?> dd,
                                                  JsonDeserializer<?> vd,
                                                  TypeDeserializer vtd)

  Fluent-factory method call to construct contextual instance.

### createContextual

    public CollectionDeserializer createContextual(DeserializationContext ctxt,
                                                   BeanProperty property)
                                            throws JsonMappingException

  Method called to finalize setup of this deserializer, when it is known for which property deserializer is needed for.

  Specified by:
    `createContextual` in interface `ContextualDeserializer`
  Parameters:
    `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
    `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
  Returns:
    Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
  Throws:
    `JsonMappingException`

### getContentType

    public JavaType getContentType()

  Description copied from class: `ContainerDeserializerBase`
  Accessor for declared type of contained value elements; either exact type, or one of its supertypes.

  Specified by:
    `getContentType` in class `ContainerDeserializerBase<Collection<Object>>`

### getContentDeserializer

    public JsonDeserializer<Object> getContentDeserializer()

  Description copied from class: `ContainerDeserializerBase`
  Accesor for deserializer use for deserializing content values.

  Specified by:
    `getContentDeserializer` in class `ContainerDeserializerBase<Collection<Object>>`

### deserialize

    public Collection<Object> deserialize(com.fasterxml.jackson.core.JsonParser jp,
                                          DeserializationContext ctxt)
                                   throws IOException,
                                          com.fasterxml.jackson.core.JsonProcessingException

  Description copied from class: `JsonDeserializer`
  Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

  Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

  Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

  Specified by:
    `deserialize` in class `JsonDeserializer<Collection<Object>>`
  Parameters:
    `jp` - Parsed used for reading JSON content
    `ctxt` - Context that can be used to access information about this deserialization activity.
  Returns:
    Deserializer value
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserialize

    public Collection<Object> deserialize(com.fasterxml.jackson.core.JsonParser jp,
                                          DeserializationContext ctxt,
                                          Collection<Object> result)
                                   throws IOException,
                                          com.fasterxml.jackson.core.JsonProcessingException

  Description copied from class: `JsonDeserializer`
  Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used for all supported types; most commonly it is used for Collections and Maps.

  Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

  Overrides:
    `deserialize` in class `JsonDeserializer<Collection<Object>>`
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeWithType

    public Object deserializeWithType(com.fasterxml.jackson.core.JsonParser jp,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException,
                                      com.fasterxml.jackson.core.JsonProcessingException

  Description copied from class: `StdDeserializer`
  Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.

  Overrides:
    `deserializeWithType` in class `StdDeserializer<Collection<Object>>`
    `typeDeserializer` - Deserializer to use for handling type information
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2012 fasterxml.com. All Rights Reserved.